<?php

namespace STM\DB\SQL;

use \Exception;

/**
 * Test class for Condition.
 * Generated by PHPUnit on 2011-09-02 at 10:32:39.
 * @group database
 */
class ConditionTest extends \PHPUnit_Framework_TestCase {

    private $bad_values;
    private $invalid_instances;
    private $valid_instances;

    protected function setUp() {
        $this->bad_values = array('', null, false, array(), 0, 235, new Exception());

        $this->invalid_instances = array();
        foreach ($this->bad_values as $value) {
            $this->invalid_instances[] = new Condition($value);
        }

        $this->valid_instances = array();
        $this->valid_instance = new ConditionTest('id = {1}', array('id' => 5));
        $this->valid_instance = new ConditionTest('id = 5');
    }

    protected function tearDown() {}

    public function testAdd_condition() {
        foreach ($this->invalid_instances as $instance) {
            foreach ($this->bad_values as $value) {
                // $condition must be string
                $instance->addCondition($value);
                $this->assertFalse($instance->isValid());

                // $values are added only if $condition is non empty
                $instance->addCondition('', $value);
                $this->assertFalse($instance->isValid());

                // $condition must be string AND $values must be array - 
                $instance->addCondition($value, $value);
                $this->assertFalse($instance->isValid());
            }
        }

        foreach ($this->valid_instances as $instance) {
            $instance->addCondition('(name = {N})', array('N' => 'zdenda'));
            $this->assertTrue(is_int(strpos($instance->__toString(), "name = 'zdenda'")));

            $instance->addCondition("city = 'Makov'");
            $this->assertTrue(is_int(strpos($instance->__toString(), "city = 'Makov'")));
        }
    }
    
    public function testRemoveCondition() {
        $original_text = 'id is null and number > 50';
        $condition = new Condition($original_text);        
        $condition->removeCondition('test');
        $this->assertTrue($condition->__toString() == $original_text);        
        $condition->removeCondition('ID IS NULL');
        $this->assertTrue($condition->__toString() == $original_text);
        $condition->removeCondition('id is null');
        $this->assertTrue($condition->__toString() == ' number > 50');
    }

    public function testisValid() {
        foreach ($this->invalid_instances as $instance) {
            $this->assertFalse($instance->isValid());
        }        

        foreach ($this->valid_instances as $instance) {
            $this->assertTrue($instance->isValid());
        }
    }

    public function testEscape_values() {
        $this->markTestSkipped('Escaping in Database class, Condition only gives values for escaping');
    }

    public function test__toString() {
        foreach ($this->invalid_instances as $instance) {
            $this->assertTrue($instance->__toString() == '');
        }        

        foreach ($this->valid_instances as $instance) {
            $this->assertTrue(is_string($instance->__toString()));
        }
    }

}

?>
